/*
	ppps_int_stack.c
	[TvCu] int^̃X^bN
	
	author:  K.Y (Programming Place Plus)
	
	version  1.0.2   '2019/9/20
	           EWebTCg C99Ki֑ΉƂɍ킹āAR[hCB
			     RgX^CƁAϐ錾ʒuςB
                 bool^gB
             
             1.0.1   '2013/1/26
	           Eppps_int_stack_try_pop֐ǉB
			   EO֌JȂ֐ static tB

	         1.0.0   '2012/7/7
*/

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include "ppps_int_stack.h"

static void* xmalloc(size_t size);


struct PPPSIntStack_tag {
	int*    data;    // vfi[铮Iz
	size_t  size;    // data ̗vf
	size_t  top;     // ŏi̓Y
};


/* X^bN */
PPPSIntStack ppps_int_stack_create(size_t size)
{
	assert( size > 0 );
	
	struct PPPSIntStack_tag* stack = xmalloc( sizeof(struct PPPSIntStack_tag) );
	stack->data = xmalloc( sizeof(int) * size );
	stack->size = size;
	stack->top = 0;

	return stack;
}

/* X^bN폜 */
void ppps_int_stack_delete(PPPSIntStack stack)
{
	free( stack->data );
	free( stack );
}

/* X^bNɗvfς */
void ppps_int_stack_push(PPPSIntStack stack, int value)
{
	assert( stack->top < stack->size );

	stack->data[stack->top] = value;
	stack->top += 1;
}

/* X^bNvf~낷 */
int ppps_int_stack_pop(PPPSIntStack stack)
{
	assert( !ppps_int_stack_is_empty(stack) );

	stack->top -= 1;
	return stack->data[stack->top];
}

/* X^bNvf~낷 (۔t) */
bool ppps_int_stack_try_pop(PPPSIntStack stack, int* p)
{
	assert( p != NULL );

	if( ppps_int_stack_is_empty(stack) ){
		return false;
	}

	stack->top -= 1;
	*p = stack->data[stack->top];

	return true;
}

/* X^bN󂩂ǂׂ */
bool ppps_int_stack_is_empty(PPPSIntStack stack)
{
	return stack->top <= 0;
}


/* G[`FbNt malloc֐ */
void* xmalloc(size_t size)
{
	void* p = malloc( size );
	if( p == NULL ){
		fputs( "蓖ĂɎs܂B", stderr );
		exit( EXIT_FAILURE );
	}
	return p;
}
