/*
	ppps_int_clist.h
	[TvCu] int^̑ozXg
	
	author:  K.Y (Programming Place Plus)
	
	version  1.0.2   '2019/9/16
	           EWebTCg C99Ki֑ΉƂɍ킹āAR[hCB
			     RgX^CƁAϐ錾ʒuςB
                 bool^gB
             
             1.0.0   '2015/1/11
*/

#ifndef PPPS_INT_CLIST_H
#define PPPS_INT_CLIST_H

#include <stdbool.h>

/*
	ozXg^
*/
struct PPPSIntClist_tag {
	int                        value;
	struct PPPSIntClist_tag*   next;
	struct PPPSIntClist_tag*   prev;
};
typedef struct PPPSIntClist_tag* PPPSIntClist;



/*
	Xg쐬

	߂lF
		쐬ꂽXgB
		쐬Ɏsꍇ NULL ԂB
*/
PPPSIntClist ppps_int_clist_create(void);

/*
	Xgj

	F
		list:	j郊XgB
*/
void ppps_int_clist_delete(PPPSIntClist list);

/*
	Xg̖ɗvfǉ

	F
		list:	ǉΏۂ̃XgB
		value:	ǉvf̒lB
	߂lF
		vf̒ǉɐ 0ȊOAs 0 ԂB
*/
bool ppps_int_clist_add_tail(PPPSIntClist list, int value);

/*
	Xg̐擪ɗvfǉ

	F
		list:	ǉΏۂ̃XgB
		value:	ǉvf̒lB
	߂lF
		vf̒ǉɐ 0ȊOAs 0 ԂB
*/
bool ppps_int_clist_add_front(PPPSIntClist list, int value);

/*
	Xgɗvf}

	F
		list:	ǉΏۂ̃XgB
		value:	ǉvf̒lB
		pos:	}ʒuBƓlvf̒ɑ}B
	߂lF
		vf̒ǉɐ 0ȊOAs 0 ԂB
*/
bool ppps_int_clist_insert(PPPSIntClist list, int value, int pos);

/*
	vf폜

	F
		list:	ǉΏۂ̃XgB
		valueF	폜vf̒lB
	߂lF
		폜łvf̌ԂB
*/
int ppps_int_clist_remove_elem_by_value(PPPSIntClist list, int value);

/*
	vf폜

	F
		elem:   폜vf
	߂lF
		vf̍폜ɐ 0ȊOAs 0 ԂB
*/
bool ppps_int_clist_remove_elem(PPPSIntClist elem);

/*
	Xgɂ

	F
		list:	Ώۂ̃XgB
*/
void ppps_int_clist_clear(PPPSIntClist list);

/*
	擪̗vfԂ

	F
		list:	Ώۂ̃XgB
	߂lF
		AXg̐擪ɂvfw|C^B
		vf̏ꍇ NULLB
*/
PPPSIntClist ppps_int_clist_get_head(PPPSIntClist list);

/*
	̗vfԂ

	F
		list:	Ώۂ̃XgB
	߂lF
		AXg̖ɂvfw|C^B
		vf̏ꍇ NULLB
*/
PPPSIntClist ppps_int_clist_get_tail(PPPSIntClist list);

/*
	w肵lvfT

	F
		list:	Ώۂ̃XgB
		valueF	Tovf̒lB
	߂lF
		擪AXgHAŏɌ value Ɠlvf̃AhXB
		Ȃꍇ NULL ԂB
*/
PPPSIntClist ppps_int_clist_search(PPPSIntClist list, int value);

/*
	Xg̗vf̌Ԃ

	F
		list:	Ώۂ̃XgB
	߂lF
		Xgɑ݂vf̌B
*/
int ppps_int_clist_count(PPPSIntClist list);

/*
	XgtɂB

	F
		list:	Ώۂ̃XgB
*/
void ppps_int_clist_reverse(PPPSIntClist list);

/*
	vfo͂

	F
		list:	Ώۂ̃XgB
*/
void ppps_int_clist_print(PPPSIntClist list);


#endif

