/*
	ppps_int_list.c
	[TvCu] int^̑o`Xg
	
	author:  K.Y (Programming Place Plus)
	
	version  1.0.2   '2019/9/16
	           EWebTCg C99Ki֑ΉƂɍ킹āAR[hCB
			     RgX^CƁAϐ錾ʒuςB
                 bool^gB

	         1.0.1	'2018/3/19
	           Eppps_int_list_insert֐ŁA}ʒuXg̖ꍇɁA
	             nOAbvoOCB
		
             1.0.0   '2015/1/10
*/

#include "ppps_int_list.h"
#include <stdio.h>
#include <stdlib.h>

#define PPP_SWAP(type,a,b) { type work = a; a = b; b = work; }


/*
	Xg쐬
*/
PPPSIntList ppps_int_list_create(void)
{
	struct PPPSIntList_tag* head = malloc( sizeof(struct PPPSIntList_tag) );
	if( head == NULL ){
		return NULL;
	}

	head->value = 0;
	head->next = NULL;
	head->prev = NULL;

	return head;
}

/*
	Xgj
*/
void ppps_int_list_delete(PPPSIntList list)
{
	ppps_int_list_clear( list );

	free( list );
}

/*
	Xg̖ɗvfǉ
*/
bool ppps_int_list_add_tail(PPPSIntList list, int value)
{
	// Xg̖T
	PPPSIntList tail = ppps_int_list_search_tail( list );

	// ǉvf
	PPPSIntList elem = malloc( sizeof(struct PPPSIntList_tag) );
	if( elem == NULL ){
		return false;
	}
	elem->value = value;
	elem->next = NULL;   // ɒǉ̂ŁA̗vf͖
	elem->prev = tail;   // ɒǉ̂ŁAO̗vf͂܂łɖvf

	// ܂Ŗvf́AQԖڂ̈ʒuɂȂB
	// ̂߁AnextoāAVȖ̗vfw悤ɂ
	tail->next = elem;

	return true;
}

/*
	Xg̐擪ɗvfǉ
*/
bool ppps_int_list_add_front(PPPSIntList list, int value)
{
	// ǉvf
	PPPSIntList elem = malloc( sizeof(struct PPPSIntList_tag) );
	if( elem == NULL ){
		return false;
	}
	elem->value = value;
	elem->next = list->next;
	elem->prev = list;

	// ǉvf̗̎vf΁AO̗vfƂĒǉvfݒ
	if( elem->next != NULL ){
		elem->next->prev = elem;
	}

	// _~[̐擪vf̎́AǉvfɂȂ
	list->next = elem;

	return true;
}

/*
	Xgɗvf}
*/
bool ppps_int_list_insert(PPPSIntList list, int value, int pos)
{
	// ǉʒuT
	PPPSIntList p = ppps_int_list_search( list, pos );
	if( p == NULL ){
		return false;
	}

	// ǉvf
	PPPSIntList elem = malloc( sizeof(struct PPPSIntList_tag) );
	if( elem == NULL ){
		return false;
	}
	elem->value = value;
	elem->next = p->next;  // p  p->next ̌Ԃɑ}
	elem->prev = p;        // p  p->next ̌Ԃɑ}

    // p ̒ɒǉ̂ŁAp->next tւ
	p->next = elem;

	// elem->next ɂƂĂ prev A} elem w悤ɕtւB
	//  }ʒuXg̖ꍇAelem->next  NULL ł邱ƂɒӁB
	if( elem->next != NULL ){
		elem->next->prev = elem;
	}
	
	return true;
}

/*
	vf폜
*/
int ppps_int_list_remove_elem_by_value(PPPSIntList list, int value)
{
	PPPSIntList p = list->next;
	PPPSIntList prev = list;
	int count = 0;

	while( p != NULL ){
		if( p->value == value ){
			// 폜vf̂P̗vf prevóAA
			// 폜vf̂PO̗vfw悤ɏB
			// AP̗̌vf݂Ȃ\lȂ΂ȂȂB
			if( p->next != NULL ){
				p->next->prev = prev;
			}

			// 폜vf̂PO̗vf nextoA
			// 폜vf̗̎vfw悤ɏ
			prev->next = p->next;

			// vf malloc֐Ő̂ŁAfree֐ɂKvB
			// L prev->next = p->next ōsȂƁAsȃ|C^
			// prev->next ɑĂ܂ƂɒӁB
			free( p );

			// sȂAp 𐳂vfw悤ɂ
			p = prev->next;

			++count;
		}
		else{
			prev = p;
			p = p->next;
		}
	}

	return count;
}

/*
	vf폜
*/
bool ppps_int_list_remove_elem(PPPSIntList elem)
{
	if( elem == NULL ){
		return false;
	}

	if( elem->prev != NULL ){
		elem->prev->next = elem->next;
	}
	if( elem->next != NULL ){
		elem->next->prev = elem->prev;
	}

	free( elem );
	return true;
}

/*
	vfɂ
*/
void ppps_int_list_clear(PPPSIntList list)
{
	PPPSIntList p = list->next;

	while( p != NULL ){
		// 폜vf̂P̗vf̃|C^ۑ
		PPPSIntList tmp = p->next;

		// vf malloc֐Ő̂ŁAfree֐ɂKvB
		// free֐ʂ p ͕sɂȂ̂ŁǍ p->next ͕sB
		free( p );

		// ۑĂ|C^𕜌
		p = tmp;
	}

	list->next = NULL;
}

/*
	擪̗vfԂ
*/
PPPSIntList ppps_int_list_get_head(PPPSIntList list)
{
	return list->next;
}

/*
	̗vfT
*/
PPPSIntList ppps_int_list_search_tail(PPPSIntList list)
{
	PPPSIntList p = list;

	while( p->next != NULL ){
		p = p->next;
	}

	return p;
}

/*
	w肵lvfT
*/
PPPSIntList ppps_int_list_search(PPPSIntList list, int value)
{
	PPPSIntList p = list->next;

	while( p != NULL ){
		if( p->value == value ){
			return p;
		}
		p = p->next;
	}

	return NULL;
}

/*
	vfJEgB
	
	߂lF
		XgɊ܂܂vf̌B
*/
int ppps_int_list_count(PPPSIntList list)
{
	PPPSIntList p = list->next;
	int count = 0;

	while( p != NULL ){
		count++;
		p = p->next;
	}

	return count;
}

/*
	XgtɂB
*/
void ppps_int_list_reverse(PPPSIntList list)
{
	PPPSIntList p = list->next;
	PPPSIntList work = NULL;

	while( p != NULL ){

		// ̌Ap->next ̂őޔĂ
		PPPSIntList tmp = p->next;

		// next  prev ւ
		PPP_SWAP(PPPSIntList, p->next, p->prev);

		// ݂̒ڗvfۑ
		work = p;

		// ŏɑޔĂ p->next ̒ڗvfƂĕA
		p = tmp;
	}

	// ŏII work ́AtɂȂ̐擪vfł邩A
	// _~[̐擪vf next|C^ƂĐݒ肷
	list->next = work;

	// tɂȂ̐擪vfɂ́AO̗vf݂͑Ȃ
	list->prev = NULL;
}

/*
	vfo͂
*/
void ppps_int_list_print(PPPSIntList list)
{
	PPPSIntList p = list->next;

	if( p == NULL ){
		puts( "Xg͋łB" );
		return;
	}

	while( p != NULL ){
		printf( "%d\n", p->value );
		p = p->next;
	}
}
